package com.goldencode.testcases.dmo.p2j_test;

import com.goldencode.p2j.persist.*;
import com.goldencode.p2j.util.*;

/**
 * Data Model Object corresponding with table <code>p2j_test.`vehicle`</code>
 * (previously <code>p2j_test.vehicle</code>).
 */
public interface Vehicle
extends DataModelObject
{
   /**
    * Getter: Manufacturer
    * 
    * @return  Make
    */
   public character getMake();

   /**
    * Setter: Manufacturer
    * 
    * @param   make
    *          Make
    */
   public void setMake(Text make);

   /**
    * Getter: Vehicle model name
    * 
    * @return  Model
    */
   public character getModel();

   /**
    * Setter: Vehicle model name
    * 
    * @param   model
    *          Model
    */
   public void setModel(Text model);

   /**
    * Getter: Number of axles
    * 
    * @return  Number of axles
    */
   public integer getAxles();

   /**
    * Setter: Number of axles
    * 
    * @param   axles
    *          Number of axles
    */
   public void setAxles(NumberType axles);

   /**
    * Getter: Exterior color
    * 
    * @return  Exterior
    */
   public character getExtColor();

   /**
    * Setter: Exterior color
    * 
    * @param   extColor
    *          Exterior
    */
   public void setExtColor(Text extColor);

   /**
    * Getter: Vehicle Identification Number
    * 
    * @return  VIN
    */
   public character getVinNumber();

   /**
    * Setter: Vehicle Identification Number
    * 
    * @param   vinNumber
    *          VIN
    */
   public void setVinNumber(Text vinNumber);

   /**
    * Getter: Optional features
    * 
    * @return  Options
    */
   public character[] getOptions();

   /**
    * Indexed Getter: Optional features
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt;
    *          10</code>).
    * 
    * @return  Options
    */
   public character getOptions(int index);

   /**
    * Indexed Getter: Optional features
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt;
    *          10</code>).
    * 
    * @return  Options
    */
   public character getOptions(NumberType index);

   /**
    * Indexed Setter: Optional features
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt;
    *          10</code>).
    * @param   element
    *          Options
    */
   public void setOptions(int index, Text element);

   /**
    * Indexed Setter: Optional features
    * 
    * @param   index
    *          Index of element (where <code>0 &lt;= <em>index</em> &lt;
    *          10</code>).
    * @param   element
    *          Options
    */
   public void setOptions(NumberType index, Text element);

   /**
    * Set all elements of the target list property to the given scalar value.
    * Modifies the contents of: Optional features
    * 
    * @param   element
    *          Scalar value to which to set all elements of: Options
    */
   public void setOptions(Text element);

   /**
    * Set as many elements of the target list property as are provided in the
    * given array of scalar values. Modifies the contents of: Optional
    * features
    * <p>
    * If the given array is larger than the target list, any additional
    * elements in the given array are ignored. If the target array is smaller
    * than the target list, only those elements whose array indices match are
    * updated.
    * 
    * @param   elements
    *          Array of scalar values to which to set the corresponding
    *          elements of: Options
    */
   public void setOptions(Text[] elements);

   /**
    * Report number of list elements for Optional features
    * 
    * @return  Number of list elements for Options
    */
   public integer sizeOptions();

   /**
    * DMO interface for use by converted business logic.
    */
   public static interface Buf
   extends Vehicle, Buffer
   {
   }
}
